function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

/** @component icon */
import React from 'react';
import PropTypes from 'prop-types';
import find from 'lodash/find';
import trimEnd from 'lodash/trimEnd';
import trimStart from 'lodash/trimStart';
import iconNames from '@collab-ui/icons/data/iconNames.json';
import colors from '@collab-ui/core/data/colors.json';
import { Button } from "./..";

var Icon =
/*#__PURE__*/
function (_React$PureComponent) {
  _inheritsLoose(Icon, _React$PureComponent);

  function Icon() {
    return _React$PureComponent.apply(this, arguments) || this;
  }

  var _proto = Icon.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        ariaLabel = _this$props.ariaLabel,
        buttonClassName = _this$props.buttonClassName,
        color = _this$props.color,
        className = _this$props.className,
        description = _this$props.description,
        isAria = _this$props.isAria,
        onClick = _this$props.onClick,
        name = _this$props.name,
        size = _this$props.size,
        sizeOverride = _this$props.sizeOverride,
        style = _this$props.style,
        title = _this$props.title,
        type = _this$props.type,
        otherProps = _objectWithoutPropertiesLoose(_this$props, ["ariaLabel", "buttonClassName", "color", "className", "description", "isAria", "onClick", "name", "size", "sizeOverride", "style", "title", "type"]);

    var consoleHandler = function consoleHandler(message, data) {
      /* eslint-disable no-console */
      switch (message) {
        case 'isAria-warn':
          // TODO(pajeter): remove isAria code with next major release
          console.warn("[@collab-ui/react] Icon: isAria prop is deprecated and will be removed. Title, description or ariaLabel props should be used to add accessibility.");
          break;

        case 'color-warn':
          console.warn("[@collab-ui/react] Icon: " + data + " may not exist in the design system," + " please use a color name from https://momentum.design/styles/color/style");
          break;

        case 'color-error':
          console.warn("[@collab-ui/react] Icon: " + data + " does not exist in the design system," + " please use a color name from https://momentum.design/styles/color/style");
          break;

        case 'name-error':
          console.warn("[@collab-ui/react] Icon: Icon " + data + " does not exist in the design system." + " Visit https://momentum.design/styles/icons/library for a list of available icons or to request a new icon.");
          break;
      }
      /* eslint-enable no-console */

    };

    var getSize = function getSize() {
      var defaultSize = 16;
      var sizeFromName = Number(name.split('_')[1]);
      return size || sizeFromName || defaultSize;
    };

    var getColorSpec = function getColorSpec(colorObj) {
      return colorObj.hex ? colorObj.hex : colorObj.opacity && isolateRoot(colorObj.variable) === 'white' ? "rgba(255, 255, 255, " + colorObj.opacity / 100 + ")" : "rgba(0, 0, 0, " + colorObj.opacity / 100 + ")";
    };

    var getHexFromJSON = function getHexFromJSON(colorName) {
      for (var _iterator = colors, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : _iterator[Symbol.iterator]();;) {
        var _ref;

        if (_isArray) {
          if (_i >= _iterator.length) break;
          _ref = _iterator[_i++];
        } else {
          _i = _iterator.next();
          if (_i.done) break;
          _ref = _i.value;
        }

        var c = _ref;
        var variation = find(c.variations, ['variable', colorName]);
        if (variation) return getColorSpec(variation);
      }

      return consoleHandler('color-error', colorName);
    };

    var isolateRoot = function isolateRoot(str) {
      var trimmed = trimStart(str, '$');
      var split = trimmed.split('-');
      var root = split[0];
      return root;
    };

    var formatColor = function formatColor() {
      return color.startsWith('$') ? color : color.endsWith('-base') ? trimEnd(color, '-base') : "$" + color;
    };

    var getColor = function getColor() {
      if (!color) return 'inherit';

      if (color.startsWith('#')) {
        consoleHandler('color-warn', color);
        return color;
      }

      return getHexFromJSON(formatColor());
    };

    var getNameClass = function getNameClass() {
      var iconName = name.startsWith('icon-') ? name.replace(/^(icon-)/, '') : name;

      if (sizeOverride) {
        iconName = name.split('_')[0] + ("_" + getSize());
      }

      return iconNames.includes(iconName) ? "icon-" + iconName : consoleHandler('name-error', iconName);
    };

    var styles = _extends({
      fontSize: getSize(),
      color: getColor()
    }, style);

    var getAriaLabel = function getAriaLabel() {
      if (!isAria) return deprecationWarning(); // TODO(pajeter): remove isAria code with next major release

      if (isAria // TODO(pajeter): remove isAria code with next major release
      && ariaLabel) {
        return ariaLabel;
      }

      if (!ariaLabel) {
        if (title && description) return title + " " + description;
        if (title) return title;
        if (description) return description;
      }

      return null;
    };

    var deprecationWarning = function deprecationWarning() {
      // TODO(pajeter): remove isAria code with next major release
      consoleHandler('isAria-warn');
    };

    var getIcon = function getIcon() {
      return React.createElement("i", _extends({
        className: "cui-icon icon" + (" " + getNameClass()) + ("" + (className && " " + className || '')),
        "aria-label": !onClick ? getAriaLabel() : null,
        style: styles
      }, !onClick && _extends({}, otherProps)));
    };

    return onClick ? React.createElement(Button, _extends({
      className: 'cui-button--icon' + ("" + (type && " cui-button--icon-" + type || '')) + ("" + (buttonClassName && " " + buttonClassName || '')),
      ariaLabel: getAriaLabel(),
      onClick: onClick
    }, otherProps), getIcon()) : getIcon();
  };

  return Icon;
}(React.PureComponent);

Icon.propTypes = {
  /** @prop Text to display for blindness accessibility features | null */
  ariaLabel: PropTypes.string,

  /** @prop Optional Button class name string | '' */
  buttonClassName: PropTypes.string,

  /** @prop Optional color css styling | '' */
  color: PropTypes.string,

  /** @prop Optional class name string | '' */
  className: PropTypes.string,

  /** @prop Icon description text | '' */
  description: PropTypes.string,

  /** @prop Depreciated prop that supports accessibility features | true */
  isAria: PropTypes.bool,
  // TODO(pajeter): remove isAria code with next major release

  /** @prop Required Icon name */
  name: PropTypes.string.isRequired,

  /** @prop Handler invoked by click of the user | null */
  onClick: PropTypes.func,

  /** @prop Sets Icon size | null */
  size: PropTypes.number,
  // Internal prop to override iconName with size prop */
  sizeOverride: PropTypes.bool,

  /** @prop Additional style properties to be applied | null */
  style: PropTypes.object,

  /** @prop Sets Icon Title prop | '' */
  title: PropTypes.string,

  /** @prop Sets Icon Type | '' */
  type: PropTypes.oneOf(['', 'white'])
};
Icon.defaultProps = {
  ariaLabel: null,
  buttonClassName: '',
  color: '',
  className: '',
  description: '',
  isAria: true,
  // TODO(pajeter): remove isAria code with next major release
  onClick: null,
  size: null,
  sizeOverride: false,
  style: null,
  title: '',
  type: ''
};
Icon.displayName = 'Icon';
export default Icon;